VERSION 5.00
Begin VB.UserControl Line 
   BackColor       =   &H00C0C0C0&
   CanGetFocus     =   0   'False
   ClientHeight    =   255
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2040
   ForeColor       =   &H00000000&
   ScaleHeight     =   17
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   136
   ToolboxBitmap   =   "Line.ctx":0000
   Begin VB.Line Line2 
      BorderColor     =   &H00FFFFFF&
      X1              =   0
      X2              =   136
      Y1              =   8
      Y2              =   8
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808080&
      BorderWidth     =   2
      X1              =   0
      X2              =   136
      Y1              =   8
      Y2              =   8
   End
End
Attribute VB_Name = "Line"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'    
Option Explicit

' ,  
'  
Dim CurrentStyle As Integer

'   
Event Resize()
Event LightColorChanged()
Event DarkColorChanged()
Event BackColorChanged()
Event StyleChanged()


Sub About()
On Error GoTo BackColorPropGet_Err
MsgBox "3D Line ActiveX .  " & App.Major & "." & Format(App.Minor, "00") & "." & Format(App.Revision, "0000"), 64, " "
Exit Sub

' :
BackColorPropGet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "   "" "".", 48, App.Title

End Sub


Public Property Get Style() As Integer
Attribute Style.VB_MemberFlags = "3c"
'  Style
On Error GoTo StylePropGet_Err
Style = CurrentStyle
Exit Property

' :
StylePropGet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""Style"".", 48, App.Title
End Property
Public Property Let Style(ByVal StyleValue As Integer)
'  Style
On Error GoTo StylePropLet_Err
If StyleValue > 1 Or StyleValue < 0 Then
    MsgBox ":" + Chr(13) + Chr(10) + "  ""Style""   0  1.", 48, App.Title
    Exit Property
End If

CurrentStyle = StyleValue
PropertyChanged Style
UserControl_Resize
RaiseEvent StyleChanged
Exit Property

' :
StylePropLet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""Style"".", 48, App.Title
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'   
On Error GoTo Read_Prop_Err
' ,   
'   
Dim OpeningProperty As Integer
OpeningProperty = 1
Style = PropBag.ReadProperty("Style", 0)
OpeningProperty = 2
DarkColor = PropBag.ReadProperty("DarkColor", &H808080)
OpeningProperty = 3
LightColor = PropBag.ReadProperty("LightColor", &HFFFFFF)
OpeningProperty = 4
BackColor = PropBag.ReadProperty("BackColor", &HC0C0C0)
Exit Sub

Read_Prop_Err:
'      ,
'    
'  
If OpeningProperty = 1 Then
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""Style""  .", 48, App.Title
    Resume Next
End If

'      ,
'    
'  
If OpeningProperty = 2 Then
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""DarkColor""  .", 48, App.Title
    Resume Next
End If

'      ,
'    
'  
If OpeningProperty = 3 Then
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""LightColor""  .", 48, App.Title
    Resume Next
End If

'      ,
'    
'  
If OpeningProperty = 4 Then
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""BackColor""  .", 48, App.Title
    Resume Next
End If
End Sub

Private Sub UserControl_Resize()
'  
On Error GoTo Resize_Err
If CurrentStyle = 0 Then
    Line1.X1 = 0
    Line2.X1 = 0
    Line1.X2 = ScaleWidth - 1
    Line2.X2 = ScaleWidth
    
    Line1.Y1 = ScaleHeight \ 2
    Line2.Y1 = ScaleHeight \ 2
    Line1.Y2 = ScaleHeight \ 2
    Line2.Y2 = ScaleHeight \ 2
Else
    Line1.X1 = ScaleWidth \ 2
    Line2.X1 = ScaleWidth \ 2
    Line1.X2 = ScaleWidth \ 2
    Line2.X2 = ScaleWidth \ 2
    
    Line1.Y1 = 0
    Line2.Y1 = 0
    Line1.Y2 = ScaleHeight - 1
    Line2.Y2 = ScaleHeight
End If

'  Resize
RaiseEvent Resize
Exit Sub

'   
Resize_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "     .", 48, App.Title
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
'   
On Error GoTo Write_Prop_Err
' ,   
'   
Dim SavingProperty As Integer
SavingProperty = 1
PropBag.WriteProperty "Style", Style, 0
SavingProperty = 2
PropBag.WriteProperty "DarkColor", DarkColor, &H808080
SavingProperty = 3
PropBag.WriteProperty "LightColor", LightColor, &HFFFFFF
SavingProperty = 4
PropBag.WriteProperty "BackColor", BackColor, &HC0C0C0
Exit Sub

Write_Prop_Err:
'      ,
'    
'  
If SavingProperty = 1 Then
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""Style""  .", 48, App.Title
    Resume Next
End If

'      ,
'    
'  
If SavingProperty = 2 Then
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""DarkColor""  .", 48, App.Title
    Resume Next
End If

'      ,
'    
'  
If SavingProperty = 3 Then
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""DarkColor""  .", 48, App.Title
    Resume Next
End If

'      ,
'    
'  
If SavingProperty = 4 Then
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""BackColor""  .", 48, App.Title
    Resume Next
End If
End Sub



Public Property Get LightColor() As Long
'  Style
On Error GoTo LightColorPropGet_Err
LightColor = Line2.BorderColor
Exit Property

' :
LightColorPropGet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""Colors"".", 48, App.Title
End Property

Public Property Get DarkColor() As Long
'  Style
On Error GoTo DarkColorPropGet_Err
DarkColor = Line1.BorderColor
Exit Property

' :
DarkColorPropGet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""DarkColor"".", 48, App.Title
End Property
Public Property Let LightColor(ByVal ColorValue As Long)
'  Colors
On Error GoTo LightColorPropLet_Err
Line2.BorderColor = ColorValue
PropertyChanged LightColor
UserControl_Resize
RaiseEvent LightColorChanged
Exit Property

' :
LightColorPropLet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""LightColor"".", 48, App.Title
End Property
Public Property Let DarkColor(ByVal ColorValue As Long)
'  DarkColor
On Error GoTo DarkColorPropLet_Err
Line1.BorderColor = ColorValue
PropertyChanged DarkColor
UserControl_Resize
RaiseEvent DarkColorChanged
Exit Property

' :
DarkColorPropLet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""DarkColor"".", 48, App.Title
End Property

Public Property Get BackColor() As Long
'  BackColor
On Error GoTo BackColorPropGet_Err
BackColor = UserControl.BackColor
Exit Property

' :
BackColorPropGet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""BackColor"".", 48, App.Title
End Property

Public Property Let BackColor(ByVal ColorValue As Long)
'  BackColor
On Error GoTo DarkColorPropLet_Err
UserControl.BackColor = ColorValue
PropertyChanged BackColor
UserControl_Resize
RaiseEvent BackColorChanged
Exit Property

' :
DarkColorPropLet_Err:
    MsgBox ":" + Chr(13) + Chr(10) + _
        "      ""BackColor"".", 48, App.Title
End Property
